--[[ $Id $ ]]--
CombatDnd = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0")

local Waterfall = AceLibrary("Waterfall-1.0")
local L = AceLibrary("AceLocale-2.2"):new("CombatDnd")

------

CombatDnd.Options = {
  type = "group",
  args = {
    text = {
      type  = "text",
      name  = L["Text"],
      desc  = L["Change your dnd text."],
      usage = L["<Text>"],
      get   = function() return CombatDnd.db.profile.text end,
      set   = "SetText",
    },
    overrideAFK = {
      type = "toggle",
      name = L["Override AFK"],
      desc = L["Override the AFK status or not."],
      get  = function() return CombatDnd.db.profile.overrideAFK end,
      set  = function(v) CombatDnd.db.profile.overrideAFK = v end,
    },
  },
}

CombatDnd:RegisterDB("CombatDndDB", "CombatDndDBPC")
CombatDnd:RegisterDefaults("profile", {
  text = L["DEFAULT_TEXT"],
  overrideAFK = false,
})

------

function CombatDnd:OnInitialize()
  AceLibrary("AceConsole-2.0"):InjectAceOptionsTable(self, self.Options)
  self:RegisterChatCommand(L["SLASH_CMD"], function() Waterfall:Open(self.name) end, "COMBATDND")
  
  Waterfall:Register(self.name,
    "title", L["CombatDnd Configuration"],
    "aceOptions", self.Options,
    "colorR", 1,
    "colorG", 0.2,
    "colorB", 0.2)
end

function CombatDnd:OnEnable()
  self:RegisterEvent("PLAYER_REGEN_DISABLED")
  self:RegisterEvent("PLAYER_REGEN_ENABLED")
end

function CombatDnd:OnDisable()
  self:UnregisterAllEvents()
end

------

function CombatDnd:PLAYER_REGEN_DISABLED()
  local db = self.db.profile
  if not UnitIsDND("player") and (db.overrideAFK or (not UnitIsAFK("player"))) then
    SendChatMessage(db.text, "DND")
    self.ChangeDnd = 1
  else
    self.ChangeDnd = nil
  end
end

function CombatDnd:PLAYER_REGEN_ENABLED()
  if UnitIsDND("player") and self.ChangeDnd then
    SendChatMessage("", "DND")
    self.ChangeDnd = 1
  end
end
------

function CombatDnd:SetText(new)
  if (new == "") or (new == "DEFAULT") then
    new = L["DEFAULT_TEXT"]
  end  
  self.db.profile.text = new
end
